Ext.define('forms.data.proxy.RestWithVersion', {extend:'Ext.data.proxy.Rest', alias:'proxy.formsRestWithVersion', appendId:false, buildUrl:function(request) {
  var me = this;
  var operation = request.getOperation();
  var records = operation.getRecords();
  var record = records ? records[0] : null;
  var version, id, url = me.callParent([request]);
  if (operation.getParams() && operation.getParams().version) {
    version = operation.getParams().version;
  } else {
    if (record) {
      version = record.get('version');
    }
  }
  if (record && !record.phantom) {
    id = record.get('id');
  } else {
    id = operation.getId();
  }
  if (id) {
    var urlTokens = url.split('?');
    url = urlTokens[0] + '/' + id;
    if (version) {
      url = url + '/' + version;
    }
    if (urlTokens[1]) {
      url = Ext.urlAppend(url, urlTokens[1]);
    }
    request.setUrl(url);
  }
  return url;
}});
Ext.define('forms.model.Form', {extend:'Ext.data.Model', requires:['forms.data.proxy.RestWithVersion'], fields:['id', 'version', 'name', 'config', {name:'timestamp', type:'date', dateFormat:'time'}], idProperty:'id', proxy:{type:'formsRestWithVersion', url:'cxf/bpc-forms/forms', writer:{type:'json', writeAllFields:true}}});
Ext.define('forms.store.Forms', {extend:'Ext.data.Store', storeId:'bpcForms', model:'forms.model.Form', sorters:[{property:'timestamp', direction:'DESC'}]});
Ext.define('forms.Config', {singleton:true, requires:['forms.store.Forms'], FORM_URL:'formUrl', RENDERER_URL:'rendererUrl', DEBUG:'debug', EMBEDDED_FORM:'embeddedForm', FORM_ID:'formId', FORM_VERSION:'formVersion', FORMS_ICON_REPOSITORY:'x-fal fa-cabinet-filing', FORMS_ICON:'x-fal fa-ballot-check', FORMS_ICON_URL:'x-fal fa-link', FORMS_ICON_EMBEDDED:'x-fal fa-brackets-curly', FORMS_ICON_CHECK:'x-fal fa-check', constructor:function() {
  Ext.create('forms.store.Forms');
}});
Ext.define('forms.BpcInterface', {extend:'BpcCommon.BpcInterface', requires:[], config:{moduleConfigurationComponents:['formsLiveView', 'formsList'], moduleInstanceConfigurationComponents:['formsModuleInstanceEditor'], defaultModuleInstanceConfigurationComponent:'formsModuleInstanceEditor', baseModuleView:'forms.view.List', mainView:null, widgets:[]}});
Ext.define('forms.model.FormVersion', {extend:'forms.model.Form', idProperty:'version'});
Ext.define('forms.plugin.Interface', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'BPC Forms Plugin', COMPONENT_XTYPE:'formsPlugin', PLUGIN_ID:'bpcForms'}});
Ext.define('forms.view.Main', {extend:'Ext.container.Container', alias:'widget.formsMain', layout:'fit', scrollable:true, moduleId:undefined, moduleCfg:undefined, moduleRoute:undefined, initialData:undefined, initComponent:function() {
  var me = this;
  me.items = [{xtype:'formsForm', formUrl:BpcCommon.Api.getSetting(me.moduleId, forms.Config.FORM_URL), formConfig:BpcCommon.Api.getSetting(me.moduleId, forms.Config.EMBEDDED_FORM), formId:BpcCommon.Api.getSetting(me.moduleId, forms.Config.FORM_ID), formVersion:BpcCommon.Api.getSetting(me.moduleId, forms.Config.FORM_VERSION), debug:BpcCommon.Api.getSetting('forms', forms.Config.DEBUG) || false, initialData:me.initialData}];
  me.callParent();
  me.form = me.down('formsForm');
  me.submitData = me.form.submitData.bind(me.form);
  me.validateData = me.form.validateData.bind(me.form);
  me.resetForm = me.form.resetForm.bind(me.form);
  me.updateInstance(me.moduleCfg, me.moduleRoute);
}, updateInstance:function() {
}});
Ext.define('forms.plugin.View', {extend:'forms.view.Main', alias:'widget.formsPlugin', initComponent:function() {
  var me = this;
  me.pluginConfiguration = me.pluginConfiguration || {};
  if (Ext.isObject(me.pluginConfiguration.configuration)) {
    Ext.apply(me, me.pluginConfiguration.configuration);
  }
  if (Ext.isObject(me.pluginConfiguration.context) && me.pluginConfiguration.context.record) {
    me.initialData = {record:me.pluginConfiguration.context.record.getData()};
  }
  me.callParent();
}});
Ext.define('FormHistory', {extend:'Ext.data.Store', model:'forms.model.Form', proxy:{type:'rest', url:'cxf/bpc-forms/history', writer:{type:'json', writeAllFields:true}}});
Ext.define('forms.view.Editor', {extend:'Ext.panel.Panel', alias:'widget.formsEditor', iconCls:BpcCommon.Icons.EDIT, viewModel:{data:{form:{id:undefined, name:undefined, version:undefined, config:undefined}}}, bind:{title:BpcCommon.lang.Current.FORMS_EDITOR + ' - {form.name} ({form.id}/{form.version})'}, layout:{type:'vbox', align:'stretch'}, form:undefined, bodyPadding:10, buttons:[{iconCls:BpcCommon.Icons.CANCEL, itemId:'cancelBtn', ui:'secondary', hidden:true, listeners:{'afterrender':function(btn) {
  var window = btn.up('window');
  if (window) {
    btn.show();
  }
}}, localized:{text:'CORE_CANCEL'}, handler:function() {
  var me = this.up('formsEditor');
  var window = me.up('window');
  if (window) {
    window.close();
  }
}}, {iconCls:BpcCommon.Icons.SAVE, itemId:'saveBtn', ui:'primary', localized:{text:'FORMS_SAVE'}, handler:function() {
  var me = this.up('formsEditor');
  var unlockFn = BpcCommon.Util.blockComponentForAsyncAction('saveBtn', 'itemId', 'CORE_SAVE', '^ formsEditor');
  me.form.save({callback:function() {
    unlockFn();
    Ext.getStore('bpcForms').reload();
    var window = me.up('window');
    if (window) {
      window.close();
    }
  }});
}}], items:[{xtype:'bpcTextField', fieldLabel:'Name', bind:'{form.name}'}, {xtype:'formsFormConfigEditor', fieldLabel:'Name', flex:1, minHeight:200, bind:'{form.config}'}], initComponent:function() {
  var me = this;
  me.getViewModel().set('form', me.form);
  me.callParent();
}});
Ext.define('forms.view.Form', {extend:'Ext.ux.IFrame', alias:'widget.formsForm', formUrl:undefined, formConfig:undefined, formId:undefined, formVersion:undefined, formModel:undefined, debug:false, iFrameCommunicationTimeout:5000, pendingRequestMap:undefined, initialData:undefined, initComponent:function() {
  var me = this;
  var language = BpcCommon.Api.getSetting('_core', 'language');
  var rendererUrl = BpcCommon.Api.getSetting('forms', forms.Config.RENDERER_URL);
  me.formUrl = me.formUrl || '';
  me.src = rendererUrl + '?formUrl\x3d' + me.formUrl + '\x26debugMode\x3d' + me.debug + '\x26language\x3d' + language + '\x26sourceId\x3d' + me.getId();
  var initIframeDeferred = new Ext.Deferred;
  initIframeDeferred.then(me.initIframe.bind(me));
  me.pendingRequestMap = {ready:initIframeDeferred};
  me.callParent();
  window.addEventListener('message', function(event) {
    var eventData = Ext.JSON.decode(event.data, true);
    if (eventData && eventData.destinationId === me.getId()) {
      me.onMessageReceived(eventData);
    }
  }, false);
}, initIframe:function() {
  var me = this;
  if (!me.formUrl || String(me.formUrl).toLowerCase() === 'iframe') {
    if (!me.formConfig) {
      return me.loadFormFromRepo().then(me.initIframe.bind(me));
    }
    me.postMessageWithBackChannel('setFormConfig', me.formConfig);
  }
  if (me.initialData) {
    me.setFormData(me.initialData);
  }
}, loadFormFromRepo:function() {
  var me = this;
  var deferred = new Ext.Deferred;
  forms.model.Form.load(String(me.formId), {params:{version:me.formVersion}, scope:me, failure:function(record, operation) {
    BpcCommon.Api.showNotification({type:'ERROR', text:'FORMS_LOAD_FAILED'});
    deferred.reject(BpcCommon.Util.getErrorFromFailureResponse(operation.getResponse()));
  }, success:function(form) {
    me.formModel = form;
    me.formConfig = form.get('config');
    deferred.resolve(form);
  }});
  return deferred.promise;
}, postMessage:function(message) {
  var me = this;
  var postMsg = message;
  if (!Ext.isString(message)) {
    postMsg = JSON.stringify(postMsg);
  }
  me.getWin().postMessage(postMsg, '*');
}, onMessageReceived:function(messageObject) {
  var me = this;
  if (messageObject.requestName && me.pendingRequestMap[messageObject.requestName]) {
    me.pendingRequestMap[messageObject.requestName].resolve(messageObject.response);
  }
  me.fireEvent('messageReceived', me, messageObject);
}, getFormConfig:function() {
  var me = this;
  return me.postMessageWithBackChannel('getFormConfig', {});
}, setFormData:function(data) {
  var me = this;
  return me.postMessageWithBackChannel('setData', data);
}, submitData:function() {
  var me = this;
  return me.postMessageWithBackChannel('submitData', {});
}, validateData:function() {
  var me = this;
  return me.postMessageWithBackChannel('validateData', {});
}, resetForm:function() {
  var me = this;
  return me.postMessageWithBackChannel('resetForm', {});
}, postMessageWithBackChannel:function(requestName, messageObject) {
  var me = this;
  if (me.pendingRequestMap[requestName]) {
    return me.pendingRequestMap[requestName].promise;
  }
  var deferred = new Ext.Deferred;
  me.pendingRequestMap[requestName] = deferred;
  me.postMessage({requestName:requestName, request:messageObject, sourceId:me.getId()});
  var promiseWithTimeout = Ext.Deferred.timeout(deferred.promise, me.iFrameCommunicationTimeout);
  promiseWithTimeout.then(function() {
    delete me.pendingRequestMap[requestName];
  }, function() {
    delete me.pendingRequestMap[requestName];
  });
  return promiseWithTimeout;
}});
Ext.define('forms.view.FormConfigEditor', {extend:'Ext.Container', alias:'widget.formsFormConfigEditor', layout:{type:'hbox', align:'stretch'}, viewModel:true, config:{value:{}, previewExpanded:false}, publishes:'value', defaultBindProperty:'value', items:[{xtype:'panel', layout:'fit', flex:1, items:[{xtype:'bpcJsonField', itemId:'formConfigJson', jsonSchema:'bpc-fe-forms/resources/formConfig.json', bind:{value:'{value}'}}]}, {xtype:'panel', itemId:'preview', iconCls:BpcCommon.Icons.PREVIEW, localized:{title:'FORMS_PREVIEW'}, 
split:true, collapsed:true, collapsable:true, titleCollapse:true, collapseDirection:'right', layout:'fit', flex:1, bind:{formConfig:'{value}'}, setFormConfig:function(formConfig) {
  this.removeAll();
  this.add({xtype:'formsForm', formConfig:formConfig, debug:this.lookupViewModel().get('debugMode'), frameName:Ext.id(null, 'forms-live-view-')});
}, items:[{html:'nothing'}]}], initComponent:function() {
  var me = this;
  me.callParent();
  me.getViewModel().bind('{value}', me.setValue, me);
}});
Ext.define('forms.view.FormConfigLiveView', {extend:'Ext.panel.Panel', alias:'widget.formsLiveView', localized:{title:'FORMS_LIVE_VIEW'}, iconCls:BpcCommon.Icons.PREVIEW, layout:{type:'hbox', align:'stretch'}, viewModel:{data:{formConfig:{'metaData':{'author':'Virtimo AG', 'name':'Live PReview Form', 'id':999999, 'version':1}, 'components':[{'layout':'vertical', 'components':[{'type':'html', 'value':'\x3cb\x3eLive\x3c/b\x3e View'}, {'id':'lastName', 'label':{'de':'Nachname', 'en':'Lastname'}, 'type':'textfield', 
'value':'/data/lastName'}, {'id':'firstName', 'label':{'de':'Vorname', 'en':'Firstname'}, 'type':'textfield', 'value':'/data/firstName'}, {'layout':'vertical', 'components':[{'layout':'horizontal', 'components':[{'id':'street', 'label':{'de':'Straße', 'en':'Street'}, 'type':'textfield', 'value':'/data/address/street'}, {'id':'streetNumber', 'label':{'de':'Hausnummer', 'en':'Number'}, 'type':'textfield'}], 'type':'container'}, {'layout':'horizontal', 'components':[{'id':'city', 'label':{'de':'Stadt', 
'en':'City'}, 'type':'textfield'}, {'id':'country', 'label':{'de':'Land', 'en':'Country'}, 'type':'textfield'}], 'type':'container'}], 'label':{'de':'Adresse', 'en':'Address'}, 'type':'fieldset'}, {'id':'consent', 'label':{'de':'OK?', 'en':'O.K.?'}, 'type':'checkbox'}, {'layout':'horizontal', 'components':[{'action':'reset', 'label':{'de':'Zurücksetzen', 'en':'reset'}, 'type':'button'}, {'action':'validate', 'label':{'de':'Formular validieren', 'en':'validate form'}, 'type':'button'}, {'action':'submit', 
'label':{'de':'Formular abschicken', 'en':'submit form'}, 'type':'button'}], 'type':'container'}], 'type':'container'}], 'dataSchema':{'type':'object', 'properties':{'lastName':{'minLength':1, 'description':'The last part of the name', 'type':'string'}, 'firstName':{'minLength':1, 'description':'The first part of the name', 'type':'string'}}, 'required':['lastName']}, 'configuration':{'validateOnChange':false, 'defaultLanguage':'de', 'validateOnBlur':true}, 'state':{'data':{}, 'language':'de'}}, 
debugMode:false}}, items:[{xtype:'panel', layout:'fit', width:600, buttons:[{xtype:'bpcModuleInstanceSelector', baseModuleName:'forms', localized:{fieldLabel:'FORMS_LOAD_FROM_FORM'}, labelWidth:250, flex:1, collapseDirection:'left', forceSelection:true, listeners:{change:function(cmp, formsInstanceId) {
  var unlockFn = BpcCommon.Util.blockComponentForAsyncAction(cmp.id, 'id', undefined, '^ formsLiveView');
  var formUrl = BpcCommon.Api.getSetting(formsInstanceId, forms.Config.FORM_URL);
  if (formUrl && formUrl !== 'iframe') {
    Ext.Ajax.request({url:formUrl, success:function(response) {
      BpcCommon.Api.showNotification(BpcCommon.Api.getTranslation('FORMS_LOADED_FORM_URL') + ' - ' + formUrl);
      cmp.lookupViewModel().set('formConfig', Ext.decode(response.responseText, true));
    }, callback:unlockFn});
    return;
  }
  var formConfig = BpcCommon.Api.getSetting(formsInstanceId, forms.Config.EMBEDDED_FORM);
  if (Ext.isObject(formConfig) && formConfig) {
    cmp.lookupViewModel().set('formConfig', formConfig);
    BpcCommon.Api.showNotification('FORMS_LOADED_EMBEDDED_FORM');
    return unlockFn();
  }
  forms.model.Form.load(String(BpcCommon.Api.getSetting(formsInstanceId, forms.Config.FORM_ID)), {params:{version:BpcCommon.Api.getSetting(formsInstanceId, forms.Config.FORM_VERSION)}, failure:function() {
    BpcCommon.Api.showNotification({type:'ERROR', text:'FORMS_LOAD_FAILED'});
  }, success:function(form) {
    cmp.lookupViewModel().set('formConfig', form.get('config'));
  }, callback:unlockFn});
  return unlockFn();
}}}, {xtype:'checkbox', bind:'{debugMode}', fieldLabel:'debug'}], items:[{xtype:'bpcJsonField', bind:{value:'{formConfig}'}}]}, {xtype:'splitter', collapsible:true, collapseTarget:'prev'}, {xtype:'container', layout:'fit', flex:1, border:1, style:{borderStyle:'solid'}, bind:{formConfig:'{formConfig}'}, setFormConfig:function(formConfig) {
  this.removeAll();
  this.add({xtype:'formsForm', formConfig:formConfig, debug:this.lookupViewModel().get('debugMode'), frameName:'forms-live-view'});
}, items:[{html:'nothing'}]}]});
Ext.define('forms.view.FormSourceSelector', {extend:'Ext.form.field.Picker', alias:'widget.formsFormSourceSelector', createPicker:function() {
  var me = this;
  return Ext.create({xtype:'tabpanel', reference:'pickerTabPanel', publishes:['activeTab'], itemId:'formsPicker', plugins:['bpcFocusKeeper'], floating:true, pickerField:me, minHeight:300, viewModel:{formulas:{isRepoVisible:function(get) {
    return get('pickerTabPanel.activeTab.itemId') === 'repository';
  }, isUrlVisible:function(get) {
    return get('pickerTabPanel.activeTab.itemId') === 'url';
  }}}, items:[{xtype:'grid', itemId:'repository', localized:{title:'FORMS_REPOSITORY'}, iconCls:forms.Config.FORMS_ICON_REPOSITORY, store:'bpcForms', columnLines:true, selType:'checkboxmodel', columns:[{text:'ID', dataIndex:'id'}, {text:'Version', dataIndex:'version'}, {text:'Name', dataIndex:'name', flex:1}, {localized:{text:'CORE_DATE'}, xtype:'datecolumn', dataIndex:'timestamp'}], listeners:{afterrender:function(grid) {
    grid.store.load();
  }}}, {xtype:'panel', itemId:'url', publishes:['hidden'], localized:{title:'FORMS_SOURCE_URL'}, iconCls:forms.Config.FORMS_ICON_URL, items:[{xtype:'bpcTextField', localized:{fieldLabel:'FORMS_URL'}}]}, {localized:{title:'FORMS_SOURCE_EMBEDDED'}, iconCls:forms.Config.FORMS_ICON_EMBEDDED, xtype:'formsFormConfigEditor', flex:1}], buttons:[{xtype:'bpcGridFilterField', grid:'^ #formsPicker #repository', flex:1, bind:{hidden:'{!isRepoVisible}'}}, {iconCls:forms.Config.FORMS_ICON_CHECK, ui:'secondary', 
  bind:{hidden:'{!isUrlVisible}'}, localized:{text:'FORMS_URL_TEST'}}, '-\x3e', {iconCls:BpcCommon.Icons.SAVE, ui:'primary', localized:{text:'CORE_SAVE'}}]});
}, listeners:{'click':{fn:function() {
  this.component.expand();
}, element:'inputEl'}}});
Ext.define('forms.view.List', {extend:'Ext.grid.Panel', alias:'widget.formsList', controller:'formsListController', localized:{title:'FORMS_REPOSITORY'}, iconCls:forms.Config.FORMS_ICON_REPOSITORY, store:'bpcForms', plugins:{ptype:'rowexpander', rowBodyTpl:'\x3cdiv id\x3d"{[BpcCommon.Util.cleanUpId(\'bpcFormsHistoryFor-\' + values.id)]}"\x3e\x3c/div\x3e'}, buttons:[{iconCls:BpcCommon.Icons.REFRESH, ui:'secondary', localized:{text:'CORE_REFRESH'}, handler:function() {
  var me = this;
  me.up('formsList').store.reload();
}}, {iconCls:BpcCommon.Icons.ADD, ui:'primary', localized:{text:'FORMS_ADD'}, handler:'addForm'}], columns:[{text:'ID', dataIndex:'id'}, {text:'Version', dataIndex:'version'}, {text:'Name', dataIndex:'name', flex:1}, {localized:{text:'CORE_DATE'}, xtype:'datecolumn', dataIndex:'timestamp'}, {xtype:'actioncolumn', text:'', width:64, align:'center', items:[{iconCls:BpcCommon.Icons.PREVIEW, localized:{tooltip:'FORMS_PREVIEW'}, handler:'previewForm'}, {iconCls:BpcCommon.Icons.EDIT, localized:{tooltip:'FORMS_EDITOR'}, 
handler:'editForm'}]}], listeners:{afterrender:function(grid) {
  grid.store.load();
}}});
Ext.define('form.view.ListController', {extend:'Ext.app.ViewController', alias:'controller.formsListController', control:{'formsList \x3e gridview':{expandbody:'onExpandBody', collapsebody:'onCollapseBody'}}, defaultFormConfig:{'metaData':{'name':'Example Form', 'id':1, 'version':1}, 'components':[{'layout':'vertical', 'components':[{'label':{'de':'Name', 'en':'name'}, 'type':'textfield', 'value':'/data/name'}], 'type':'container'}], 'configuration':{}, 'state':{'data':{'name':'Mia Mustermensch'}}}, 
addForm:function() {
  var me = this;
  Ext.create({xtype:'bpcWindow', maximizable:true, items:[{xtype:'formsEditor', form:Ext.create('forms.model.Form', {id:Date.now(), version:1, name:'Form', config:me.defaultFormConfig})}]}).show();
}, editForm:function(tableView, rowIndex, colIndex, item, e, record) {
  Ext.create({xtype:'bpcWindow', maximizable:true, items:[{xtype:'formsEditor', form:record}]}).show();
}, previewForm:function(tableView, rowIndex, colIndex, item, e, record) {
  Ext.create({xtype:'bpcWindow', maximizable:true, items:[{xtype:'formsForm', formId:record.get('id'), formVersion:record.get('version')}]}).show();
}, onExpandBody:function(rowNode, record) {
  var me = this;
  var target = Ext.get(BpcCommon.Util.cleanUpId('bpcFormsHistoryFor-' + record.getId()));
  var visibleWidth = me.getView().getView().getWidth() - 64;
  var parentWidth = target.getWidth();
  record.historyCmp = Ext.create({xtype:'grid', controller:me, store:{model:'forms.model.FormVersion', autoLoad:true, proxy:{type:'rest', url:'cxf/bpc-forms/history/' + record.getId()}}, width:parentWidth < visibleWidth ? parentWidth : visibleWidth, columns:Object.getPrototypeOf(me.getView()).columns, renderTo:target, resizable:{handles:'s'}, padding:0});
}, onCollapseBody:function(rowNode, record) {
  if (record.historyCmp) {
    record.historyCmp.destroy();
  }
}});
Ext.define('forms.view.ModuleInstanceEditor', {extend:'Ext.panel.Panel', alias:'widget.formsModuleInstanceEditor', localized:{title:'FORMS_EDITOR'}, iconCls:forms.Config.FORMS_ICON, layout:{type:'vbox', align:'stretch'}, bodyPadding:10, items:[{xtype:'bpcTextField', localized:{fieldLabel:'CORE_NAME'}, bind:{value:'{moduleInstance.module_name}'}}, {xtype:'formsFormSourceSelector', localized:{fieldLabel:'FORMS_SOURCE'}}], buttons:[{ui:'primary', localized:{text:'CORE_SAVE'}, iconCls:BpcCommon.Icons.SAVE, 
handler:function(btn) {
  btn.lookupViewModel().get('moduleInstance.moduleModel').save();
}}]});
